
        .XCREF
        .NOLIST
        INCLUDE    \masm32\include\masm32rt.inc
        .586
        INCLUDE    \masm32\macros\timers.asm
        .LIST

;timers.asm written by MichaelW
;ShowCPU written by jj2007

;#################################################################################

Macro1  MACRO

        push    Label0
        pop     Label1
        sub     esp,4
        pop     Label2

ENDM

;*********************************************************************************

Macro2  MACRO

        mov     eax,Label0
        mov     Label1,eax
        mov     Label2,eax

ENDM

;#################################################################################

LOOP_COUNT = 10000000

;#################################################################################

ShowCPU	PROTO   :DWORD

;#################################################################################

        .DATA

Label0  dd ?
Label1  dd ?
Label2  dd ?

;*********************************************************************************

;        .DATA?

;#################################################################################

        .CODE

;*********************************************************************************

_main   PROC

;----------------------------------------

;bind the process to a single core

        INVOKE  GetCurrentProcess
        INVOKE  SetProcessAffinityMask,eax,1
        INVOKE  Sleep,750

;----------------------------------------

        mov     edi,5

loop00:
        counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS

size10:
        Macro1
size11:

        counter_end

        print   str$(eax),' '
        dec     edi
        jnz     loop00

        print   chr$(13,10)
        mov     eax,size11-size10
        print   str$(eax),13,10

;----------------------------------------

        mov     edi,5

loop01:
        counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS

size20:
        Macro2
size21:

        counter_end

        print   str$(eax),' '
        dec     edi
        jnz     loop01

        print   chr$(13,10)
        mov     eax,size21-size20
        print   str$(eax),13,10

;----------------------------------------

;show the CPU

        INVOKE  ShowCPU,1

;----------------------------------------

;terminate

        inkey
        exit

_main   ENDP

;*********************************************************************************

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
ShowCPU proc mode:DWORD

;ShowCPU written by Jochen (jj2007)

; Usage:

; call ShowCPU for the short,

; push -127
; call ShowCPU for the long version

  push ebx
  ifndef MyCPU
	.data?
	CpuFlags		dd ?
	CpuExFlags	dd ?
	CpuMMX	dd ?
	CpuSSE	dd ?
	CpuFxSR	dd ?
	CpuManu	dd 20 dup (?)
	CpuInfo	dd 100 dup (?)
	stepping	dd ?
	model	dd ?
	family	dd ?
	ptype	dd ?
	extmodel	dd ?
	extfamily	dd ?
	.data
	txStep	db "Step           ", 9, 0
	txModel	db 13, 10, "Model        ", 9, 0
	txFam	db 13, 10, "Family       ", 9, 0
	txType	db 13, 10, "Type          ", 9, 0
	txExtM	db 13, 10, "Ext model   ", 9, 0
	txExtF	db 13, 10, "Ext family   ", 9, 0
	txCpuMan	db 13, 10, "Manufacturer", 9, 0
	txP1	db "P1 (1993+)", 0
	txPro	db "Pentium Pro (1995+)", 0
	txP2	db "P2 (1997+)", 0
	txP3	db "P3 (2000+)", 0
	txP4	db "P4 (2000+)", 0
	txIta1	db "Itanium 1 (2001+)", 0
	txIta2	db "Itanium 2 (2002+)", 0
	txPM	db "Pentium M (2003+)", 0
	txCore	db "Core (2006+)", 0
	txCore2	db "Core Duo (2006+)", 0
	txP4Prescott	db "Pentium 4 Prescott (2005+)", 0
	txUnknownP4	db "Pentium 4 (?)", 0
	txUnknown	db "?", 0
	.code
  endif
  xor eax, eax
  db 0Fh, 0A2h		; cpuid 0
  mov CpuManu, ebx
  mov CpuManu[4], edx
  mov CpuManu[8], ecx
  push 1
  pop eax
  db 0Fh, 0A2h	; 					; cpuid 1
  mov CpuFlags, edx
  mov CpuExFlags, ecx
  and CpuMMX, 0
  and CpuSSE, 0

  mov ebx, eax
  and eax, 15
  mov stepping, eax

  shr ebx, 4
  mov eax, ebx
  and eax, 15
  mov model, eax

  shr ebx, 4
  mov eax, ebx
  and eax, 15
  mov family, eax

  shr ebx, 4
  mov eax, ebx
  and eax, 15
  mov ptype, eax

  shr ebx, 4
  mov eax, ebx
  and eax, 15
  mov extmodel, eax

  shr ebx, 4
  mov eax, ebx
  and eax, 15
  mov extfamily, eax

  invoke lstrcpy, offset CpuInfo, offset txStep
  invoke lstrcat, offset CpuInfo, str$(stepping)
  
  invoke lstrcat, offset CpuInfo, offset txModel
  invoke lstrcat, offset CpuInfo, str$(model)

  invoke lstrcat, offset CpuInfo, offset txFam
  invoke lstrcat, offset CpuInfo, str$(family)

  invoke lstrcat, offset CpuInfo, offset txType
  invoke lstrcat, offset CpuInfo, str$(ptype)

  invoke lstrcat, offset CpuInfo, offset txExtM
  invoke lstrcat, offset CpuInfo, str$(extmodel)

  invoke lstrcat, offset CpuInfo, offset txExtF
  invoke lstrcat, offset CpuInfo, str$(extfamily)

  invoke lstrcat, offset CpuInfo, offset txCpuMan
  invoke lstrcat, offset CpuInfo, offset CpuManu

  mov eax, [esp+8]
  .if eax==-127
	print "CPU family ",
	print str$(family), ", model "
	print str$(model), ", "
  .endif
  
  COMMENT @
[url=http://www.pagetable.com/?p=18]CPUID Family codes[/url]
* 486 (1989): family 4
* Pentium (1993): family 5
* Pentium Pro (1995): family 6, models 0 and 1
* Pentium 2 (1997): family 6, models 3, 5 and 6
* Pentium 3 (2000): family 6, models 7, 8, 10, 11
* Itanium (2001): family 7
* Pentium 4 (2000): family 15/0
* Itanium 2 (2002): family 15/1 and 15/2
* Pentium M (2003): family 6, models 9 and 13
* Core (2006): family 6, model 14
* Core 2 (2006): family 6, model 15 @
  .if family==5
	mov edx, offset txP1
  .elseif family==6
	.if model<=1
		mov edx, offset txPro
	.elseif model==3 || model==5 || model==6
		mov edx, offset txP2
	.elseif model==7 || model==8 || model==10 || model==11
		mov edx, offset txP3
	.elseif model==9 || model==13
		mov edx, offset txPM
	.elseif model==14
		mov edx, offset txCore
	.elseif model==15
		mov edx, offset txCore2
	.endif
  .elseif family==7	; Itanium
		mov edx, offset txIta1
  .elseif family==15
	.if model==0
		mov edx, offset txP4
	.elseif model<=2
		mov edx, offset txIta2
	.elseif model==4
		mov edx, offset txP4Prescott
	.else
		mov edx, offset txUnknownP4
	.endif
  .else
	mov edx, offset txUnknown
  .endif
  print edx
  mov edx, CpuFlags
  ; MsgBox 0, BIN$(edx, f), "Hi", MB_OK
  bt edx, 23
  .if Carry?
	inc CpuMMX
	print ", MMX, SSE"
  .else
	print ", no MMX, SSE"
  .endif

  mov edx, CpuFlags
  bt edx, 24
  jnc @F
  inc CpuFxSR	; supports FXSAVE, FXRSTOR
@@:

  bt edx, 25
  jnc @F
  inc CpuSSE
@@:

  bt edx, 26
  jnc @F
  inc CpuSSE
@@:

  mov ecx, CpuExFlags
  bt ecx, 0
  jnc @F
  inc CpuSSE
@@:
  print str$(CpuSSE), 13, 10
  pop ebx
  mov eax, [esp+4]
  .if eax==-127
	print offset CpuInfo, 13, 10
	ret 4
  .else
	ret
  .endif
ShowCPU endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

;#################################################################################

        END     _main

